global function placeWarGameObjects

struct
{
    bool isthere = false
} file

const int moveTime = 2
const int moveDistance = 75

void function placeWarGameObjects()
{
    CreateSimpleButton( <758, 0, 66>, <0, 90, 0>, " to control the bridge", callback_ButtonTriggered )
    
    // CreatePropDynamic( $"models/levels_terrain/mp_wargames/wargames_upmart_glitch.mdl", <758, 70, 64>, <0, 135, 0>, SOLID_VPHYSICS, 10000 )

    for( int x = 0; x < 5; x++ )
    {
        foreach( int offset in [-moveDistance,0,moveDistance]  )
        {
            entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", <88 - offset, -342, -148>, <0,0,0>, SOLID_VPHYSICS, 1000 )
            mover.SetPusher( true )
            mover.SetScriptName( "wargames_bridge2"+x )
        }
    }

    for( int x = 0; x < 5; x++ )
    {
        foreach( int offset in [-moveDistance,0,moveDistance]  )
        {
            entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", <88 - offset, 347, -148>, <0,0,0>, SOLID_VPHYSICS, 1000 )
            mover.SetPusher( true )
            mover.SetScriptName( "wargames_bridge1"+x )
        }
    }

    CreateNessy( < -536.204, 142.314, 204.031 >, <0, 0, 0> )
}

void function callback_ButtonTriggered( entity panel, entity player )
{
    if ( !file.isthere )
    {
        thread extandBridge1()
        thread extandBridge2()
    }
    else
    {
        thread contractBridge2()
        thread contractBridge1()
    }

    file.isthere = !file.isthere
}

void function extandBridge2()
{
    for( int x = 0; x < 5; x++ )
    {
        foreach( entity mover in GetEntArrayByScriptName( "wargames_bridge2"+x )  )
        {
            mover.NonPhysicsMoveTo( mover.GetOrigin() + <0,moveDistance*x,15>, moveTime, 0.1, 0.1 )
        }
        wait moveTime + 0.3
    }
}

void function extandBridge1()
{
    for( int x = 0; x < 5; x++ )
    {
        foreach( entity mover in GetEntArrayByScriptName( "wargames_bridge1"+x )  )
        {
            mover.NonPhysicsMoveTo( mover.GetOrigin() + <0,-moveDistance*x,15>, moveTime, 0.1, 0.1 )
        }
        wait moveTime + 0.3
    }
}

void function contractBridge2()
{
    for( int x = 4; x >= 0; x-- )
    {
        foreach( entity mover in GetEntArrayByScriptName( "wargames_bridge2"+x )  )
        {
            mover.NonPhysicsMoveTo( mover.GetOrigin() + <0,-moveDistance*x,-15>, moveTime, 0.1, 0.1 )
        }
        wait moveTime + 0.3
    }
}

void function contractBridge1()
{
    for( int x = 4; x >= 0; x-- )
    {
        foreach( entity mover in GetEntArrayByScriptName( "wargames_bridge1"+x )  )
        {
            mover.NonPhysicsMoveTo( mover.GetOrigin() + <0,moveDistance*x,-15>, moveTime, 0.1, 0.1 )
        }
        wait moveTime + 0.3
    }
}
